Use the Oracle Database@Google Cloud remote MCP server

This document shows you how to use the Oracle Database@Google Cloud remote Model Context Protocol (MCP) server to connect with AI applications including Antigravity, ChatGPT, Claude, and custom applications you are developing. The Oracle Database@Google Cloud remote MCP server lets you access and run Oracle Database@Google Cloud tools to manage Oracle Database@Google Cloud resources from your AI-enabled development environments and AI agent platforms. The Oracle Database@Google Cloud remote MCP server is enabled when you enable the Oracle Database@Google Cloud API.

Model Context Protocol (MCP) standardizes how large language models (LLMs) and AI applications or agents connect to external data sources. MCP servers let you use their tools, resources, and prompts to take actions and get updated data from their backend service.

Remote MCP servers run on the service's infrastructure and offer an HTTP endpoint to AI applications for communication between the AI MCP client and the MCP server. For more information about MCP architecture, see MCP architecture.

Stateless core

With MCP version 2026-07-28, MCP changes from a bidirectional, stateful protocol to a stateless protocol. Each MCP request is self-describing and can be routed using headers. There isn't a need for the initialize/initialized handshake or Mcp-Session-Id because each request includes all the information needed in HTTP headers or the _meta parameter. MCP servers can request additional information required by a tool through multi-round-trip requests (MRTR).

To help route and process requests without parsing the request body, some MCP headers are required, including the following:

  • Headers that are required by the MCP specification such as the protocol version header and standard request headers.
  • Custom headers that are defined by the MCP server. These headers are mirrored into HTTP headers from the tool's input schema using the x-mcp-header property. For example, an MCP server might define a custom header to specify the Google Cloud region or project ID.

For more information about MCP architecture, see the MCP version 2026-07-28 specification and key changes.

Google and Google Cloud remote MCP servers

Google and Google Cloud remote MCP servers have the following features and benefits:

  • Simplified, centralized discovery
  • Managed global or regional HTTP endpoints
  • Fine-grained authorization
  • Optional prompt and response security with Model Armor protection
  • Centralized audit logging

For information about other MCP servers and information about security and governance controls available for Google Cloud MCP servers, see Google Cloud MCP servers overview.

Limitations

  • For Autonomous AI Databases and DB systems, the create_autonomous_database tool and create_db_system tool, respectively, support only secrets stored in Secret Manager. They don't support raw passwords.

  • While Secret Manager provides a secure storage mechanism, project administrators, users with the secretmanager.versions.access permission, or users with permissions to modify IAM policies (such as, resourcemanager.projects.setIamPolicy) can potentially access the secrets, even if IAM deny policies are in place.

  • If the database_connection_executesql tool returns a response that's larger than 10 MB, then the response are truncated. Truncation is signaled by metadata.status = PARTIAL and partialResult: true.

  • When using the database_connection_executesql tool, queries that run for longer than 30 seconds can time out.

  • SQL errors don't fail the call. If Oracle rejects a statement (for example, ORA-00942), the tool returns successfully with metadata.status = ERROR and the Oracle message in metadata.message. If a statement is rejected, check the status.

  • Only one statement per call, autocommit. Multiple statements and multi-call transactions aren't supported.

  • Hostnames aren't supported in connection strings yet. Use the database's private IP.

Before you begin

  1. Sign in to your Google Cloud account. If you're new to Google Cloud, create an account to evaluate how our products perform in real-world scenarios. New customers also get $300 in free credits to run, test, and deploy workloads.
  2. In the Google Cloud console, on the project selector page, select or create a Google Cloud project.

    Roles required to select or create a project

    • Select a project: Selecting a project doesn't require a specific IAM role—you can select any project that you've been granted a role on.
    • Create a project: To create a project, you need the Project Creator role (roles/resourcemanager.projectCreator), which contains the resourcemanager.projects.create permission. Learn how to grant roles.

    Go to project selector

  3. If you're using an existing project for this guide, verify that you have the permissions required to complete this guide. If you created a new project, then you already have the required permissions.

  4. Enable the Oracle Database@Google Cloud API, if it is not already enabled.

    Roles required to enable APIs

    To enable APIs, you need the serviceusage.services.enable permission. If you created the project, then you likely already have this permission through the Owner role (roles/owner). Otherwise, you can get this permission through the Service Usage Admin role (roles/serviceusage.serviceUsageAdmin). Learn how to grant roles.

    Enable the API

  5. Install the Google Cloud CLI.

  6. If you're using an external identity provider (IdP), you must first sign in to the gcloud CLI with your federated identity.

  7. To initialize the gcloud CLI, run the following command:

    gcloud init
  8. In the Google Cloud console, on the project selector page, select or create a Google Cloud project.

    Roles required to select or create a project

    • Select a project: Selecting a project doesn't require a specific IAM role—you can select any project that you've been granted a role on.
    • Create a project: To create a project, you need the Project Creator role (roles/resourcemanager.projectCreator), which contains the resourcemanager.projects.create permission. Learn how to grant roles.

    Go to project selector

  9. If you're using an existing project for this guide, verify that you have the permissions required to complete this guide. If you created a new project, then you already have the required permissions.

  10. Enable the Oracle Database@Google Cloud API, if it is not already enabled.

    Roles required to enable APIs

    To enable APIs, you need the serviceusage.services.enable permission. If you created the project, then you likely already have this permission through the Owner role (roles/owner). Otherwise, you can get this permission through the Service Usage Admin role (roles/serviceusage.serviceUsageAdmin). Learn how to grant roles.

    Enable the API

  11. Install the Google Cloud CLI.

  12. If you're using an external identity provider (IdP), you must first sign in to the gcloud CLI with your federated identity.

  13. To initialize the gcloud CLI, run the following command:

    gcloud init

Required roles

We recommend that you follow the principles of least privilege, which states that principals should have no more permissions than they actually need. You can create a custom role as per your requirements. For example, a "SQL runner" role for an application or agent that contains the following permissions:

oracledatabase.databaseConnections.get
oracledatabase.databaseConnections.list
oracledatabase.databaseConnections.executeSql

To get the permissions that you need to use the Oracle Database@Google Cloud MCP server, ask your administrator to grant you the following IAM roles on the project where you want to use the Oracle Database@Google Cloud MCP server:

For more information about granting roles, see Manage access to projects, folders, and organizations.

These predefined roles contain the permissions required to use the Oracle Database@Google Cloud MCP server. To see the exact permissions that are required, expand the Required permissions section:

Required permissions

The following permissions are required to use the Oracle Database@Google Cloud MCP server:

  • Make MCP tool calls: mcp.tools.call
  • ODB Network and ODB Subnet:
    • oracledatabase.odbNetworks.create
    • oracledatabase.odbSubnets.create
    • oracledatabase.odbNetworks.list
    • oracledatabase.odbNetworks.get
    • oracledatabase.odbNetworks.use
  • Exadata Infrastructure instance:
    • oracledatabase.cloudExadataInfrastructures.create
    • oracledatabase.cloudExadataInfrastructures.list
    • oracledatabase.cloudExadataInfrastructures.get
  • Exadata VM Cluster:
    • oracledatabase.cloudVmClusters.create
    • oracledatabase.cloudVmClusters.list
    • oracledatabase.cloudVmClusters.get
  • Exascale VM Cluster:
    • oracledatabase.exadbVmClusters.create
    • oracledatabase.exadbVmClusters.list
    • oracledatabase.exadbVmClusters.get
  • Exascale Storage Vault:
    • oracledatabase.exascaleDbStorageVaults.create
    • oracledatabase.exascaleDbStorageVaults.list
    • oracledatabase.exascaleDbStorageVaults.get
  • Autonomous AI Database:
    • oracledatabase.autonomousDatabases.create
    • oracledatabase.autonomousDatabases.list
    • oracledatabase.autonomousDatabases.get
  • DB system:
    • oracledatabase.dbSystems.create
    • oracledatabase.dbSystems.list
    • oracledatabase.dbSystems.get
  • Oracle Goldengate:
    • oracledatabase.goldenGateDeployments.create
    • oracledatabase.goldenGateConnections.create
    • oracledatabase.goldenGateConnectionAssignments.create
    • oracledatabase.goldenGateDeployments.list
    • oracledatabase.goldenGateConnections.list
    • oracledatabase.goldenGateConnectionAssignments.list
    • oracledatabase.goldenGateDeployments.get
    • oracledatabase.goldenGateConnections.get
    • oracledatabase.goldenGateConnectionAssignments.get
  • Database connections:
    • oracledatabase.databaseConnections.create
    • oracledatabase.databaseConnections.list
    • oracledatabase.databaseConnections.get
    • oracledatabase.databaseConnections.executeSql

You might also be able to get these permissions with custom roles or other predefined roles.

Authentication and authorization

The Oracle Database@Google Cloud remote MCP server uses the OAuth 2.0 protocol with Identity and Access Management (IAM) for authentication and authorization. All Google Cloud identities are supported for authentication to MCP servers.

The Oracle Database@Google Cloud remote MCP server doesn't accept API keys.

We recommend that you create a separate identity for agents that are using MCP tools so that access to resources can be controlled and monitored. For more information about authentication, see Authenticate to MCP servers.

Oracle Database@Google Cloud MCP OAuth scopes

OAuth 2.0 uses scopes and credentials to determine if an authenticated principal is authorized to take a specific action on a resource. For more information about OAuth 2.0 scopes at Google, read Using OAuth 2.0 to access Google APIs.

Oracle Database@Google Cloud has the following MCP tool OAuth scopes:

Scope URI for gcloud CLI Description
https://www.googleapis.com/auth/oracle-database Create and list resources, and view information about the resources.

Additional scopes might be required on the resources accessed during a tool call. To view a list of scopes required for Oracle Database@Google Cloud, see Oracle Database@Google Cloud API.

Configure an MCP client to use the Oracle Database@Google Cloud MCP server

AI applications and agents, such as Claude or Antigravity, can instantiate an MCP client that connects to a single MCP server. An AI application can have multiple clients that connect to different MCP servers. If your application isn't listed in the client-specific guidance, then you can use the following information to connect from most applications.

In your AI application, look for a way to add or connect to a remote MCP server. For the Oracle Database@Google Cloud MCP server, enter the following information as required:

  • Server name: Oracle Database@Google Cloud MCP server
  • Server URL or Endpoint: https://oracledatabase.googleapis.com/mcp
  • Transport: Streamable HTTP
  • Authentication details: depending on how you want to authenticate, you can enter your Google Cloud credentials, your OAuth Client ID and secret, or an agent identity and credentials. For more information about authentication, see Authenticate to MCP servers.
  • OAuth scope: the OAuth 2.0 scope that you want to use when connecting to the Oracle Database@Google Cloud MCP server.

Redirect URIs

For web-based applications, and some desktop applications, you must allowlist a redirect URI when you create a client ID and secret for authentication. Redirect URIs are used by the authorization server to send tokens to your application. Your application's documentation should specify the redirect URI that you must use. Custom redirect URIs aren't supported.

For application-specific guidance about setting up and connecting to MCP server, see Client-specific guidance.

For more general guidance, see the following resources:

Available tools

To view details of available MCP tools and their descriptions for the Oracle Database@Google Cloud MCP server, see the Oracle Database@Google Cloud MCP reference.

List tools

Use the MCP inspector to list tools, or send a tools/list HTTP request directly to the Oracle Database@Google Cloud remote MCP server. The tools/list method doesn't require authentication.

curl -X POST https://oracledatabase.googleapis.com/TOOLSET_ENDPOINT \
    -H 'Content-Type: application/json' \
    -H 'Accept: application/json' \
    -H 'MCP-Protocol-Version: MCP_PROTOCOL_VERSION' \
    -H 'Mcp-Method: tools/list' \
    -d '{
      "jsonrpc": "2.0",
      "id": 1,
      "method": "tools/list",
      "params": {
        "_meta": {
          "io.modelcontextprotocol/protocolVersion": "MCP_PROTOCOL_VERSION",
          "io.modelcontextprotocol/clientCapabilities": {
            "extensions": {
              "io.modelcontextprotocol/ui": {
                "mimeTypes": ["text/html;profile=mcp-app"]
              }
            }
          }
        }
      }
    }'

Replace the following:

  • TOOLSET_ENDPOINT: the toolset endpoint for Oracle Database@Google Cloud MCP server which is https://oracledatabase.googleapis.com/mcp.
  • MCP_PROTOCOL_VERSION: the MCP protocol version. For example, 2026-07-28.

Execute SQL statements

You can execute all types of SQL statements including data manipulation language (DML), data definition language (DDL), and data query language (DQL).

Make sure that you've an ODB Network for the database on which you want to execute SQL statements.

To execute SQL statements, create a Database Connection for your ODB Network, and then use this connection to execute SQL statements on your database.

Execute read-only SQL statements

To execute read-only SQL statements, do the following:

  1. Create a database user with read-only permissions.
  2. Create a Database Connection with this user.
  3. Use this Database Connection to execute read-only SQL statements. Then, if an agent or LLM attempts write operations, they're rejected by the database.

Sample use cases

The following are sample use cases for the Oracle Database@Google Cloud MCP server.

Create a Database Connection

You can create a Database Connection using the following sample prompt:

"Create a Database Connection CONNECTION_ID for my Autonomous AI Database DATABASE_ID using secret "projects/PROJECT_ID/secrets/SECRET_ID/versions/SECRET_VERSION"."

In the prompts, replace the following:

  • CONNECTION_ID: a unique ID for the Database Connection.
  • DATABASE_ID: the ID of your Autonomous AI Database.
  • PROJECT_ID: the ID of your Google Cloud project that contains the secret.
  • SECRET_ID: the ID of the secret.
  • SECRET_VERSION: the version of the secret that contains the user's password.

Web application development

A sample use case might be the rapid development of web applications and the provisioning of Autonomous AI Database as their source database. In this use case, using the Oracle Database@Google Cloud MCP server lets you build a new database and populate it with initial data for a new project using natural language.

Sample prompt:

"Create a new Autonomous AI Database and set up a table called products."

Workflow: the workflow for setting up a web application might look like the following:

  • Provisioning: The agent calls the create_odb_network to create an ODB Network with service connectivity enabled through Private Service Connect-interface network attachment, and then the create_autonomous_database tool to create a new Autonomous AI Database with development environment-sized specifications.

  • Verification: The agent uses the get_operation tool to poll the status of the database creation operation.

  • Connection: When the operation is complete, the agent uses the get_autonomous_database tool to retrieve the database connection metadata. The agent also calls the create_database_connection tool to create a new Database Connection.

  • Schema setup: The agent creates the database and then uses the database_connection_executesql to run the CREATE TABLE products SQL statement.

  • Data seeding: The agent uses database_connection_executesql again to insert initial seed data (DML) into the newly created table.

Operational and database configuration management

In this sample use case, you might review existing Autonomous AI Database instances to help ensure they meet operational configuration standards.

Sample prompt:

"List all the Autonomous AI Databases in my project and show me their details to verify that they're using the same configuration."

Workflow: the workflow for checking database configuration might look like the following.

  • Discovery: The agent uses list_autonomous_databases to retrieve a list of all Autonomous AI Databases in the project.

  • Inspection: For each database identified, the agent calls get_autonomous_database to fetch detailed configuration metadata, such as the database version and region.

  • Reporting: The agent summarizes the findings, highlighting any databases that deviate from the expected configuration.

Optional security and safety configurations

MCP introduces new security risks and considerations due to the wide variety of actions that you can do with the MCP tools. To minimize and manage these risks, Google Cloud offers default settings and customizable policies to control the use of MCP tools in your Google Cloud organization or project.

For more information about MCP security and governance, see AI security and safety.

Use Model Armor

Model Armor is a Google Cloud service designed to enhance the security and safety of your AI applications. It works by proactively screening LLM prompts and responses, protecting against various risks and supporting responsible AI practices. Whether you are deploying AI in your cloud environment, or on external cloud providers, Model Armor can help you prevent malicious input, verify content safety, protect sensitive data, maintain compliance, and enforce your AI safety and security policies consistently across your diverse AI landscape.

When Model Armor is enabled with logging enabled, Model Armor logs the entire payload. This might expose sensitive information in your logs.

MCP request routing to Model Armor

Model Armor is available in certain regions. When Model Armor is enabled and you use an MCP server in a jurisdiction that Model Armor doesn't support, the routing behavior of the call might be different for different MCP servers and might break data residency compliance for in-use and in-transit data. For more information about the behavior of individual MCP servers, see Model Armor supported products.

Enable Model Armor

You must enable Model Armor APIs before you can use Model Armor.

Console

  1. Enable the Model Armor API, if it is not already enabled.

    Roles required to enable APIs

    To enable APIs, you need the serviceusage.services.enable permission. If you created the project, then you likely already have this permission through the Owner role (roles/owner). Otherwise, you can get this permission through the Service Usage Admin role (roles/serviceusage.serviceUsageAdmin). Learn how to grant roles.

    Enable the API

  2. Select the project where you want to activate Model Armor.

gcloud

Before you begin, follow these steps using the Google Cloud CLI with the Model Armor API:

  1. In the Google Cloud console, activate Cloud Shell.

    Activate Cloud Shell

    At the bottom of the Google Cloud console, a Cloud Shell session starts and displays a command-line prompt. Cloud Shell is a shell environment with the Google Cloud CLI already installed and with values already set for your current project. It can take a few seconds for the session to initialize.

  2. Run the following command to set the API endpoint for the Model Armor service.

    gcloud config set api_endpoint_overrides/modelarmor "https://modelarmor.LOCATION.rep.googleapis.com/"

    Replace LOCATION with the region where you want to use Model Armor.

Configure protection for Google and Google Cloud remote MCP servers

To help protect your MCP tool calls and responses you can use Model Armor floor settings. A floor setting defines the minimum security filters that apply across the project. This configuration applies a consistent set of filters to all MCP tool calls and responses within the project.

Set up a Model Armor floor setting with MCP sanitization enabled. For more information, see Configure Model Armor floor settings.

See the following example command:

gcloud model-armor floorsettings update \
--full-uri='projects/PROJECT_ID/locations/global/floorSetting' \
--enable-floor-setting-enforcement=TRUE \
--add-integrated-services=GOOGLE_MCP_SERVER \
--google-mcp-server-enforcement-type=INSPECT_AND_BLOCK \
--enable-google-mcp-server-cloud-logging \
--malicious-uri-filter-settings-enforcement=ENABLED \
--add-rai-settings-filters='[{"confidenceLevel": "MEDIUM_AND_ABOVE", "filterType": "DANGEROUS"}]'

Replace PROJECT_ID with your Google Cloud project ID.

Note the following settings:

  • INSPECT_AND_BLOCK: The enforcement type that inspects content for the Google MCP server and blocks prompts and responses that match the filters.
  • ENABLED: The setting that enables a filter or enforcement.
  • MEDIUM_AND_ABOVE: The confidence level for the Responsible AI - Dangerous filter settings. You can modify this setting, though lower values might result in more false positives. For more information, see Model Armor confidence levels.

Disable scanning MCP traffic with Model Armor

To stop Model Armor from automatically scanning traffic to and from Google MCP servers based on the project's floor settings, run the following command:

gcloud model-armor floorsettings update \
  --full-uri='projects/PROJECT_ID/locations/global/floorSetting' \
  --remove-integrated-services=GOOGLE_MCP_SERVER

Replace PROJECT_ID with the Google Cloud project ID. Model Armor doesn't automatically apply the rules defined in this project's floor settings to any Google MCP server traffic.

Model Armor floor settings and general configuration can impact more than just MCP. Because Model Armor integrates with services like Vertex AI, any changes you make to floor settings can affect traffic scanning and safety behaviors across all integrated services, not just MCP.

Control MCP use with IAM policies

Identity and Access Management (IAM) deny policies and allow policies help you secure Google Cloud and Google MCP servers.

You can combine multiple criteria to build customized security and governance policies by allowing or denying access based on the following:

  • The principal.
  • Tool properties like the read-only attribute.
  • The service name or tool name.
  • The application's OAuth client ID.

For more information, see Control MCP use with Identity and Access Management.

What's next